/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataGithubOrganizationIpAllowListConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/integrations/github/6.3.0/docs/data-sources/organization_ip_allow_list#id DataGithubOrganizationIpAllowList#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
export interface DataGithubOrganizationIpAllowListIpAllowListStruct {
}
export declare function dataGithubOrganizationIpAllowListIpAllowListStructToTerraform(struct?: DataGithubOrganizationIpAllowListIpAllowListStruct): any;
export declare function dataGithubOrganizationIpAllowListIpAllowListStructToHclTerraform(struct?: DataGithubOrganizationIpAllowListIpAllowListStruct): any;
export declare class DataGithubOrganizationIpAllowListIpAllowListStructOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataGithubOrganizationIpAllowListIpAllowListStruct | undefined;
    set internalValue(value: DataGithubOrganizationIpAllowListIpAllowListStruct | undefined);
    get allowListValue(): string;
    get createdAt(): string;
    get id(): string;
    get isActive(): cdktf.IResolvable;
    get name(): string;
    get updatedAt(): string;
}
export declare class DataGithubOrganizationIpAllowListIpAllowListStructList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataGithubOrganizationIpAllowListIpAllowListStructOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/integrations/github/6.3.0/docs/data-sources/organization_ip_allow_list github_organization_ip_allow_list}
*/
export declare class DataGithubOrganizationIpAllowList extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "github_organization_ip_allow_list";
    /**
    * Generates CDKTF code for importing a DataGithubOrganizationIpAllowList resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataGithubOrganizationIpAllowList to import
    * @param importFromId The id of the existing DataGithubOrganizationIpAllowList that should be imported. Refer to the {@link https://registry.terraform.io/providers/integrations/github/6.3.0/docs/data-sources/organization_ip_allow_list#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataGithubOrganizationIpAllowList to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/integrations/github/6.3.0/docs/data-sources/organization_ip_allow_list github_organization_ip_allow_list} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataGithubOrganizationIpAllowListConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataGithubOrganizationIpAllowListConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _ipAllowList;
    get ipAllowList(): DataGithubOrganizationIpAllowListIpAllowListStructList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
